import io.reactivex.Observable
import io.reactivex.disposables.CompositeDisposable
import io.reactivex.rxkotlin.subscribeBy

fun main(args: Array<String>) {

  exampleOf("never") {

    val disposables = CompositeDisposable()

    val observable = Observable.never<Any>()

    val subscription = observable
        .doOnNext { println(it) }
        .doOnComplete { println("Completed") }
        .doOnSubscribe { println("Subscribed") }
        .doOnDispose { println("Disposed") }
        .subscribeBy(onNext = {
          println(it)
        }, onComplete = {
          println("Completed")
        })

    disposables.add(subscription)

    disposables.dispose()
  }
}